![hellgate logo](mandatory-js-project-logo.png)
----
An extensible, general purpose http-\>gemini mirror with full
javascript support

## Requirements
- nodejs
- npm
- electron
- openssh
- sh
- libgtk-2-0
- libgconf-2-4
- libxshmfence1
- libnss3
- libatk-bridge2.0-0
- libdrm2
- libgtk-3-0
- libgbm
- libasound2
- xvfb (if you're running it headless)

## Setup 
- `sudo apt install libgtk2.0-0 libgconf-2-4 libxshmfence1 libnss3 libatk-bridge2.0-0 libdrm2 libgtk-3-0 libgbm1 libasound2` (if you're on debian, other
  distros idk)
- `sudo apt install xvfb` (again, on debian)
- `git clone https://tildegit.org/sose/hellgate`
- `cd hellgate`
- `sudo npm install -g electron --unsafe-perm=true`
- `npm install`
- `./gen_cert`
- `npm start` or `xvfb-run npm start`
    - The server will listen on `[::1]:1965` by default

## Sigils
- By default, more complex sites that are rendered by hellgate are not very
  pretty, and sometimes downright unreadable
- For this, users can create website specific 'sigils' to display content in a
  certain way, or to automate certain actions on a website
- Sigils are located in the `sigils` dir and are titled with the domain name of
  their corresponding website
- See [writing sigils](writing_sigils.md) for more info on how to write sigils
  and how they work
- If you write a new sigil for a specific website, don't hesitate to send it as
  a pull request to this repo

## Notes
- As of right now the npm version of gemini-server is broken, use the version
  from github or this will not work
